﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XamDataGrid_CheckAll
{
    /// <summary>
    /// MainWindow.xaml の相互作用ロジック
    /// </summary>
    public partial class MainWindow : Window
    {

        public MainWindow()
        {
            InitializeComponent();

            this.DataContext = new ViewModel();
        }
    }

    public class ViewModel : ViewModelBase
    {
        public ViewModel()
        {
            Data = new ObservableCollection<Data>();

            for (int i = 0; i < 10; i++)
            {
                Data d = new Data { ID = i, Check = i % 4 == 0, Name = "Name " + i };
                Data.Add(d);
            }
        }


        private ObservableCollection<Data> data;

        public ObservableCollection<Data> Data
        {
            get { return data; }
            set { data = value; PropChanged("Data"); }
        }

        private bool isAllSelected;

        public bool IsAllSelected
        {
            get { return isAllSelected; }
            set
            {
                isAllSelected = value;
                PropChanged("IsAllSelected");
                foreach (Data d in Data)
                {
                    d.Check = value;
                }

            }
        }


    }

    public class Data : ViewModelBase
    {
        private int id;
        private bool check;
        private string name;

        public int ID
        {
            get { return id; }
            set { id = value; PropChanged("ID"); }
        }

        public string Name
        {
            get { return name; }
            set { name = value; PropChanged("Name"); }
        }


        public bool Check
        {
            get { return check; }
            set { check = value; PropChanged("Check"); }
        }




    }

    public class ViewModelBase : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;

        public void PropChanged(string name)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(name));
        }
    }
}
